/**
 * Directory.java
 * @author Takeshi Yamada
 */
import java.util.Vector;

public class Directory extends FileNode {

    private Vector children = new Vector();
    
    public Directory(String name) {
        super(name);
    }

    public void addChild(FileNode fileNode) {
        children.add(fileNode);
        fileNode.setParent(this);
    }
    
    public void addChild(int index, FileNode fileNode) {
        children.add(index, fileNode);
        fileNode.setParent(this);
    }

    public void removeChild(FileNode fileNode) {
        children.remove(fileNode);
    }

    public FileNode getChild(int index) {
        return (FileNode)children.get(index);
    }

    public int getIndexOfChild(FileNode child) {
        return children.indexOf(child);
    }

    public int getChildCount() {
        return children.size();
    }

    public boolean isLeaf() {
        return false;
    }

    public FileNode copy() {
        Directory copyDir = new Directory(name);
        for (int i = 0; i < children.size(); i++) {
            // qcopy 쐬Directory ɒǉ.
//            copyDir.addChild(((FileNode)children.get(i)).copy());
            copyDir.addChild(getChild(i).copy());
        }
        return copyDir;
    }

} // Directory


